#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <numeric>
#include <queue>
#include <unordered_map>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';

const lli K = 65;


struct MyStruct
{
    lli ind, k;
};

vector<lli> a;
vector<lli> res;
vector<lli> arrup[K];
vector<lli> arrdown[K];
vector<lli> arr[K];
unordered_map<lli, vector<MyStruct>> mps;
unordered_map<lli, vector<MyStruct>> mpb;
vector<lli> dv[K];


void build(lli u, lli l, lli r, lli ind)
{
    if (l == r) {
        dv[ind][u] = arr[ind][l];
        return;
    }
    lli m = (l + r) / 2;
    build(u * 2 + 1, l, m, ind);
    build(u * 2 + 2, m+1, r, ind);
    dv[ind][u] = min(dv[ind][u * 2 + 1], dv[ind][u * 2 + 2]);
}

lli get(lli u, lli tl, lli tr, lli l, lli r, lli ind)
{
    if (tl > r || tr < l)return 1e9;
    if (tl >= l && tr <= r)return dv[ind][u];
    lli tm = (tl + tr) / 2;
    return min(get(u * 2 + 1, tl, tm, l, r, ind), get(u * 2 + 2, tm + 1, tr, l, r, ind));
}

void solve()
{
    lli n, q;
    cin >> n >> q;
    a.resize(n + 1);
    for (int i = 0; i < K; i++) {
        arrup[i].resize(n + 1, 1e18);
        arrdown[i].resize(n + 1, 1e18);
        arr[i].resize(n + 1, 1e18);
        dv[i].resize(4 * n, 1e18);
    }


    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) {
        lli x = a[i];
        lli cnt = 0;
        while (x % 2 == 0) {
            cnt++;
            x /= 2;
            mps[x].push_back({ i,cnt });
        }
        x = a[i];
        cnt = 0;
        while (x < 1e18) {
            x *= 2;
            mpb[x].push_back({ i,++cnt });
        }
        for (auto to : mps[a[i]])arrup[to.k][to.ind] = i;
        mps[a[i] * 2].clear();
        for (auto to : mpb[a[i]])arrdown[to.k][to.ind] = i;
        mpb[a[i]].clear();
    }
    
    for (int i = 1; i <= n; i++) {
 
        arrup[0][i] = i;
        for (int j = 1; j < K; j++)arrup[j][i] = max(arrup[j - 1][i], arrup[j][i]);


        arrdown[0][i] = i;
        for (int j = 1; j < K; j++)arrdown[j][i] = max(arrdown[j - 1][i], arrdown[j][i]);

        for (int j = 0; j < K; j++) {
            for (int k = 0; k < K; k++) {
                if (j+k<K)arr[j + k][i] = min(arr[j + k][i], max(arrup[j][i], arrdown[k][i]));
            }
        }
    }

    for (int i = 0; i < K; i++)build(0, 1, n, i);
    for (int i = 1; i <= q; i++) {
        lli l, r;
        cin >> l >> r;
        if (n > 300) {
            cout << 0 << LF;
            continue;
        }
        lli tl = 0, tr = K - 1;
        while (tl < tr) {
            lli m = (tl + tr+1) / 2;
            if (get(0, 1, n, l, r, m) <= r)tl = m;
            else tr = m - 1;
        }
        cout << tl << LF;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

