#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
ll a[500001];
int d2[500001];
int u2[500001];
unordered_map<ll,int> compress;
int fenw[500002];
void update(int pos,int val) {
    for(int i = pos+1; i < 500002; i += i&-i) {
        fenw[i] = max(val,fenw[i]);
    }
}
int query(int pos) {
    int res = 0;
    for(int i = pos+1; i > 0; i -= i&-i) {
        res = max(res,fenw[i]);
    }
    return res;
}
void clear() {
    for(int i = 0; i < 500002; i++) {
        fenw[i] = 0;
    }
}
int last_pos[500001];
int solve(int l,int r, ll x) {
    for(int i = l; i <= r;i++) {
        if(a[i] == 2*x) return 1+solve(l,r,2*x);
    }
    return 1;
}
int solve(int l,int r) {
    int mx = 0;
    for(int i = l; i <= r; i++) {
        mx = max(mx,solve(l,r,a[i]));
    }
    return mx;
}
vector<int> stupid(vector<pair<pair<int,int>,int>> Q) {
    vector<int> ans(Q.size());
    for(int i = 0; i < Q.size(); i++) {
        ans[i] = solve(Q[i].first.first,Q[i].first.second);
    }
    return ans;
}
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    n = 10;
    cin >> n;
    //cerr << n << " ";
    int q;
    q = n*(n+1)/2;
    cin >> q;
    //cerr << q << "\n";
    clear();
    compress.clear();
    for(int i = 0; i < n; i++) {
        a[i] = rnd()%10 * (1<<(rnd()%10));
        //cerr << a[i] << " ";
        cin >> a[i];
        compress[a[i]] = 1;
    }
    cerr << "\n\n";
    vector<pair<pair<int,int>,int>> Q;
    int CC = 0;
    for(int i = 0; i < q; i++) {
        // for(int j = i; j < n; j++) {
        //     //cerr << i << " " << j << "\n";
        //     Q.push_back({{i,j},CC++});
        // }
         int l,r;
        cin >> l >> r;
         l--;
         r--;
         Q.push_back({{l,r},i});
    }
    // vector<int> ans_stupid = stupid(Q);
    int cnt = 1;
    for(auto &i : compress) {
        i.second = cnt++;
    }
    for(int i = 0; i < n; i++) {
        a[i] = compress[a[i]];
    }
    for(auto e: compress) {
        if(e.first%2 == 0 and compress.contains(e.first/2)) d2[e.second] = compress[e.first/2];
        if(compress.contains(e.first*2)) u2[e.second] = compress[e.first*2];
        // cout << e.first << " " << e.second << " " << d2[e.second] << " " << u2[e.second] << "\n";
    }
    for(int i = 0; i <= cnt; i++) {
        last_pos[i] = n;
    }
    sort(Q.begin(),Q.end());
    int p = Q.size()-1;
    vector<int> ans(Q.size());
    for(int i = n-1;i >= 0;i--) {
        update(i,1);
        int j = a[i];
        vector<int> events;
        int tl = i;
        j = u2[j];
        while(j and tl < n) {
            tl = max(last_pos[j],tl);
            events.push_back(tl);
            j = u2[j];
        }
        j = a[i];
        tl = i;
        j = d2[j];
        while(j and tl < n) {
            tl = max(last_pos[j],tl);
            events.push_back(tl);
            j = d2[j];
        }
        sort(events.begin(),events.end());
        for(int k = 0; k < events.size(); k++) {
            if(k == events.size()-1 or events[k] != events[k+1]) {
                if(events[k] < n)
                    update(events[k], k+2);
            }
        }
        last_pos[a[i]] = i;
        while(p >= 0 and Q[p].first.first == i) {
            ans[Q[p].second] = query(Q[p].first.second);
            p--;
        }
    }
     // if(ans == ans_stupid) {
     //     main();
     //    return 0;
     // }
    for(int i = 0; i < q; i++) {
        cout << ans[i]-1 << "\n";
    }
    cout << "\asdasd\n";
    for(int i = 0; i < q; i++) {
        cout << ans_stupid[i]-1 << "\n";
    }
}