#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
constexpr ll mod = 1e9 + 7;
ll bin_pow(ll base, ll pow) {
    ll ans = 1;
    while (pow) {
        if(pow&1) ans*=base,ans%=mod;
        base*=base,base%=mod;
        pow >>= 1;
    }
    return ans;
}
ll fact[2000001];
ll ifact[2000001];
ll C(int n,int k) {
    if(k > n or k < 0) return 0;
    return (((fact[n]*ifact[k])%mod)*ifact[n-k])%mod;
}
ll cnt_path(int x,int y,int len) {
    assert((len-x+y)%2 == 0);
    return C(len, (len-x+y)/2);
}
ll cnt(int a1, int b1,int a2,int b2) {
    if(a1 < b1 or a2 < b2) return 0;
    if(a1 > a2 or b1 > b2) return 0;
    int len = a2-a1+b2-b1;
    int st = a1-b1;
    int end = a2-b2;
    return (cnt_path(st,end,len)-cnt_path(st,-end-2,len)+mod)%mod;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    fact[0] = 1;
    ifact[0] = 1;
    for (int i = 1; i <= 2000000; i++) {
        fact[i] = fact[i-1]*i;
        fact[i] %= mod;
        ifact[i] = bin_pow(fact[i], mod-2);
    }
    int n;
    cin >> n;
    vector<pair<int,pair<int,int>>> events;
    for(int i = 0;i < n;i++) {
        int x;
        cin >> x;
        if(i == 0) {
            if(x != 0 and x != 1) {
                cout << "0\n";
                return 0;
            }
            x = 1;
        }
        if(x) events.push_back({x,{0,i}});
    }
    for(int i = 0;i < n;i++) {
        int x;
        cin >> x;
        if(i == n-1) {
            if(x != 0 and x != 2*n) {
                cout << "0\n";
                return 0;
            }
            x = 2*n;
        }
        if(x) events.push_back({x,{1,i}});
    }
    sort(events.begin(),events.end());
    ll ans = 1;
    for(int i = 1;i < events.size();i++) {
        // cerr << events[i].first << " " << events[i].second.first << " " << events[i].second.second << "\n";
        int x,y;
        if(events[i].second.first == 0) {
            x = events[i].second.second+1;
            y = events[i].first-x;
            x--;
        }
        else {
            y = events[i].second.second+1;
            x = events[i].first-y;
            y--;
        }
        // cerr << "-- " << x << " " << y << "\n";
        int x_prev,y_prev;
        if(events[i-1].second.first == 0) {
            x_prev = events[i-1].second.second+1;
            y_prev = events[i-1].first-x_prev;
        }
        else {
            y_prev = events[i-1].second.second+1;
            x_prev = events[i-1].first-y_prev;
        }
        ans *= cnt(x_prev,y_prev,x,y);
        ans %= mod;
    }
    cout << ans << "\n";

}