#include <algorithm>
#include <climits>
#include <cmath>
#include <iostream>
#include <map>
#include <queue>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

ll binpow(ll number, ll power) {
  if (power == 1)
    return number;
  ll res = 1;
  if (power % 2 != 0) {
    power--;
    res *= number;
  }
  ll ans = binpow(number, power >> 1);
  return res * ans * ans;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll n, m, k;
  ll a, b, c, d, e, f, g, h, r, l, mx, mn, sm;
  bool bl;
  char ch;
  string str;
  cin >> n >> m >> k;
  vector<ll> arr(n);
  for (ll i = 0; i < n; i++) {
    cin >> arr[i];
  }
  if (k != 2) {
    while (m--) {
      cin >> a >> b;
      a--;
      b--;
      sm = 0;
      for (ll i = a; i <= b; i++) {
        d = 0;
        mx = 0;
        for (ll j = i; j <= b; j++) {
          if (arr[j] > mx) {
            mx = arr[j];
            d++;
          }
          sm += binpow(d, k);
        }
      }
      cout << sm << nl;
    }
  } else {
    while (m--) {
      cin >> a >> b;
      a--;
      b--;
      sm = 0;
      for (ll i = a; i <= b; i++) {
        d = 0;
        mx = 0;
        for (ll j = i; j <= b; j++) {
          d++;
          sm += binpow(d, k);
        }
      }
      cout << sm << nl;
    }
  }
}
