#include <bits/stdc++.h>
typedef long double ld;
typedef long long ll;
using namespace std;
const ll INF = 1000000;
ll a[INF];
ll tree[INF*4];
ll build(ll l, ll r, ll v){
    if(l==r){
        tree[v]=(1LL<<a[l]);
        return tree[v];
    }
    ll middle = (l+r)/2LL;
    tree[v]=build(l, middle, v*2LL+1LL)|build(middle+1LL, r, v*2LL+2LL);
    return tree[v];
}
ll answer(ll l, ll r, ll left, ll right, ll v){
    if(right<l || left>r) return 0LL;
    if(left<=l && r<=right) return tree[v];
    ll middle = (l+r)/2LL;
    return answer(l, middle, left, right, v*2LL+1LL)|answer(middle+1LL, r, left, right, v*2LL+2LL);
}
int main(){
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    ll n, q;
    cin >> n >> q;
    for(ll i = 0; i<n; i++){
        ll value;
        cin >> value;
        ll now = 1LL;
        ll count = 0LL;
        while(now!=value){
            count++;
            now*=2LL;
        }
        a[i]=count;
    }
    build(0LL, n-1LL, 0LL);
    for(ll i = 0; i<q; i++){
        ll first, second;
        cin >> first >> second;
        first--;
        second--;
        ll temp = tree[0LL];
        ll answer = 0LL;
        ll count = 0LL;
        for(ll j = 0LL; j<64LL; j++){
            if(temp&(1LL<<j)) count++;
            else count = 0LL;
            answer=max(count-1LL, answer);
        }
        cout << answer;
    }
}