#include <bits/stdc++.h>
using namespace std;

using ll = long long;

struct query {
    int l, r, i, b;
};

bool operator<(const query q1, const query q2) {
    return q1.b < q2.b || q1.b == q2.b && q1.r < q2.r;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin>>n>>q;

    ll a[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    ll k = 61;

    set<ll> s[k];

    

    int p[n + 1] = {};
    for (int i = 1; i <= n; i++) {
        ll cur = a[i];
        while (cur % 2 == 0) {
            p[i]++;
            cur /= 2;
        }
        s[p[i]].insert(i);
    }

    while (q--) {
        int l, r;
        cin >> l >> r;

        ll mask = 0;
        for (int i = 0; i < k; i++) {
            auto it = s[i].lower_bound(l);
            if (it != s[i].end() && *it <= r) {
                mask += (1LL << i);
            }
        }

        int cur = 0;
        int ans = 0;

        for (int i = 0; i < k; i++) {
            if (mask & (1LL << i)) {
                cur++;
            }
            else {
                cur = 0;
            }
            ans = max(ans, cur);
        }
        printf("%i\n", ans - 1);
    }



    

    
}
