#include <bits/stdc++.h>
using namespace std;

using ll = long long;

constexpr int MOD = 1e9 + 7;

ll binpow(ll a, ll b) {
    ll ans = 1, cur = a;
    while (b > 0) {
        if (b % 2) {
            ans = (ans * cur) % MOD;
        }
        cur = (cur * cur) % MOD;
        b /= 2;
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    
    ll a[2][n + 1];

    ll needs[2 * n + 1] = {};

    for (int i = 0; i < 2; i++) {
        for (int j = 1; j <= n; j++) {
            cin >> a[i][j];

            if (i == 0 && a[i][j] != 0) {
                needs[a[i][j]] = j - 1;
            }
            else if (i == 1 && a[i][j] != 0) {
                needs[a[i][j]] = -j;
            }
        }
    }

    n *= 2;

    ll fact[n + 1] = {};
    fact[1] = fact[0] = 1;
    for (int i = 2; i <= n; i++) {
        fact[i] = (fact[i - 1] * i) % MOD;
    }

    ll here = (fact[n] * binpow(fact[n / 2], MOD - 2)) % MOD;
    here = (here * binpow(fact[n / 2], MOD - 2)) % MOD;

    here = (here * binpow(n / 2 + 1, MOD - 2)) % MOD;

    printf("%lld\n", here);


}
