#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <numeric>
#include <queue>
#include <unordered_map>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';

const lli BSIZE = 500;

struct myq
{
    lli l, r, ind;
};

vector<lli> a;
vector<myq> qq;
vector<lli> res;
unordered_map<lli, lli> mp;
unordered_map<lli, lli> tres;
int mps[65];
set<lli> s;

bool cmp(myq q1, myq q2)
{
    if (q1.l / BSIZE == q2.l / BSIZE)return q1.r < q2.r;
    return q1.l / BSIZE < q2.l / BSIZE;
}

void myerase(lli val)
{
    mps[val]--;
    if (mps[val] == 0)s.erase(val);
}

void myinsert(lli val)
{
    mps[val]++;
    if (mps[val] == 1)s.insert(val);
}

void add(lli ind)
{
    lli x = a[ind];
    mp[x]++;
    tres[x] = tres[x * 2] + 1;
    if (mp[x] == 1) {
        myinsert(tres[a[ind]]);
        lli z = tres[a[ind]];

        while (x % 2 == 0) {
            x /= 2;
            if (mp[x] == 0)break;
            z++;
            myerase(tres[x]);
            myinsert(z);
            tres[x] = z;
        }
    }
}

void del(lli ind)
{
    lli x = a[ind];
    mp[x]--;
    if (mp[x] == 0) {
        myerase(tres[x]);
        tres[x] = 0;
        lli z = 0;
        while (x % 2 == 0) {
            x /= 2;
            if (mp[x] == 0)break;
            z++;
            myerase(tres[x]);
            myinsert(z);
            tres[x] = z;
        }
    }
}


void solve()
{
    lli n, q;
    cin >> n >> q;
    a.resize(n + 1);
    res.resize(q + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= q; i++) {
        lli l, r;
        cin >> l >> r;
        qq.push_back({ l,r,i });
    }
    sort(qq.begin(), qq.end(), cmp);
    
    lli tl = 1, tr = 0;
    for (auto to : qq) {
        while (tr<to.r)add(++tr);
        while (tl > to.l)add(--tl);
        
        while (tr > to.r)del(tr--);
        while (tl < to.l)del(tl++);

        res[to.ind] = *prev(s.end())-1;
    }
    for (int i = 1; i <= q; i++)cout << res[i] << LF;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

