#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <numeric>
#include <queue>
#include <unordered_map>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';

lli BSIZE = 200;

struct myq
{
    lli l, r, ind;
};

vector<lli> a;
vector<myq> qq;
vector<lli> res;
lli s[120];
unordered_map<lli, lli> mp;
unordered_map<lli, lli> tres;

bool cmp(myq q1, myq q2)
{
    if (q1.l / BSIZE == q2.l / BSIZE)return q1.r < q2.r;
    return q1.l / BSIZE < q2.l / BSIZE;
}



void add(lli ind)
{
    lli val = a[ind];
    mp[val]++;
    tres[val] = tres[val * 2] + 1;
    if (mp[val] == 1) {
        lli x = tres[val];
        s[x]++;
        while (val % 2 == 0) {
            val /= 2;
            x++;
            if (mp[val] == 0)break;
            s[tres[val]]--;
            tres[val] = x;
            s[x]++;
        }
    }
}

void del(lli ind)
{
    lli val = a[ind];
    mp[val]--;
    if (mp[val] == 0) {
        lli x = 0;
        s[tres[val]]--;
        tres[val] = 0;
        while (val % 2 == 0) {
            val /= 2;
            x++;
            if (mp[val] == 0)break;
            s[tres[val]]--;
            s[x]++;
            tres[val] = x;
        }
    }
}


void solve()
{
    lli n, q;
    cin >> n >> q;
    a.resize(n + 1);
    res.resize(q + 1,0);
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= q; i++) {
        lli l, r;
        cin >> l >> r;
        qq.push_back({ l,r,i });
    }
    sort(qq.begin(), qq.end(), cmp);
    lli tl = 1, tr = 0;
    for (auto to : qq) {
        while (tr<to.r)add(++tr);
        while (tl > to.l)add(--tl);
        
        while (tr > to.r)del(tr--);
        while (tl < to.l)del(tl++);

        for (int i =65; i >= 1; i--) {
            if (s[i] > 0) {
                res[to.ind] = i-1;
                break;
            }
        }
    }
    for (int i = 1; i <= q; i++)cout << res[i] << LF;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

