#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
constexpr ll mod = 1e9 + 7;
int a[5000001];
int fenw[5000005];
int fenw2[5000005];
ll N;
void add(int x, ll v) {
    for(int i = x+1; i < N; i += i & -i) {
        fenw[i] += v%mod;
        fenw[i] = (fenw[i]+mod)%mod;
    }
}
void add2(int x, ll v) {
    for(int i = x+1; i < N; i += i & -i) {
        fenw2[i] += (v*(N-x-1))%mod;
        fenw2[i] = (fenw2[i]+mod)%mod;
    }
}
void add_seq(int l,int t) {
    add(l,t);
    add2(l,t);
}
int get(int x) {
    ll res = 0;
    for(int i = x+1; i > 0; i-= i & -i) {
        res += fenw[i];
    }
    return res%mod;
}

int get2(int x) {
    ll res = 0;
    for(int i = x+1; i > 0; i-= i & -i) {
        res += fenw2[i];
    }
    return res%mod;
}
ll get_val(int x) {
    x++;
    return (get(x)*(x-N+1ll)+get2(x))%mod;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,q,t;
    cin >> n >> q >> t;
    N = n+2;
    for(int i = 0; i <  n; i++) {
        cin >> a[i];
    }
    vector<pair<pair<int,int>,int>> Q;
    for(int i = 0; i < q; i++) {
        int l,r;
        cin >> l >> r;
        l--;
        r--;
        Q.push_back({{l,r},i});
    }
    vector<int> ans(q);
    sort(Q.begin(), Q.end());
    int p = q-1;
    deque<pair<int,int>> st;
    for(int i = n-1;i >= 0;i--) {
        while (!st.empty() and st.front().first <= a[i])
            st.pop_front();
        st.push_front({a[i],i});
        for(auto e: st) {
            add_seq(e.second, 1);
        }
        while(p >= 0 and Q[p].first.first == i) {
            ans[Q[p].second] = get_val(Q[p].first.second);
            p--;
        }
    }
    for(int i = 0; i < q; i++) {
        assert(ans[i] >= 0);
        cout << (ans[i]+mod)%mod << "\n";
    }
}