#include <bits/stdc++.h>
using namespace std;

#define ll long long

using namespace std;


const int n_max = 500005;

map<ll, ll> tree[4*n_max];
ll a[n_max] = {0LL};
ll p[n_max] = {0LL};

void merge(const map<ll, ll> *m1, const map<ll, ll> *m2, map<ll, ll> *m3)
{
    auto itr1 = m1->begin();
    auto itr2 = m2->begin();
    while (itr1 != m1->end() && itr2 != m2->end()) {
        if (itr1->first == itr2->first) {
            m3->insert({itr1->first, (itr1->second|itr2->second)});
            ++itr1;
            ++itr2;
        } else {
            if (itr1->first < itr2->first) {
                m3->insert((*itr1));
                ++itr1;
            } else {
                m3->insert((*itr2));
                ++itr2;
            }
        }
    }
    for (;itr1 != m1->end(); ++itr1) {
        m3->insert((*itr1));
    }
    for (;itr2 != m2->end(); ++itr2) {
        m3->insert((*itr2));
    }
}

void buildTree(int v, int l, int r)
{
    if (l == r) {
        tree[v][a[l]] = p[l];
        return;
    }
    buildTree(2*v, l, (l+r)/2);
    buildTree(2*v+1, (l+r)/2+1, r);
    merge(&tree[2*v], &tree[2*v+1], &tree[v]);
}

map<ll, ll> *temp = new map<ll, ll>;
map<ll, ll> *ans = new map<ll, ll>;

void calc(int v, int l, int r, int tl, int tr)
{
    if (l>=tl && r<=tr) {
        merge(&tree[v], ans, temp);
        swap(ans, temp);
        temp->clear();
    } else {
        if ((l+r)/2 >= tl && l <= tr) calc(2*v, l, (l+r)/2, tl, tr);
        if ((l+r)/2+1 <= tr && r >=tl) calc(2*v+1, (l+r)/2+1, r, tl, tr);
    }
}

int max_k(ll n)
{
    while (!(n&1LL) && n) n >>= 1;
    int res = -1;
    while (n&1LL) {
        n >>= 1;
        ++res;
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin>>n>>q;
    for (int i=0;i<n;++i) {
        cin>>a[i];
        p[i] = 1LL;
        while (!(a[i]&1)) {
            a[i] >>= 1;
            p[i] <<= 1;
        }
    }
    
    buildTree(1, 0, n-1);
    
    int l, r;
    for (int i=0;i<q;++i) {
        cin>>l>>r;
        --l;
        --r;
        calc(1, 0, n-1, l, r);
        int res = 0;
        for (auto itr = ans->begin(); itr != ans->end(); ++itr) {
            res = max(res, max_k(itr->second));
        }
        ans->clear();
        cout<<res<<'\n';
    }
}
