#include <iostream>
#include <vector>
#include <map>

using namespace std;
using ll = int;

vector<map<ll, ll>> rizn(vector<vector<map<ll, ll>>> b, ll l, ll r) {
	vector<map<ll, ll>> ans(max(b[r].size(), b[l].size()) + 10);
	for (ll i = 0; i < b[l].size() && i < b[r].size(); i++) {
		for (auto j : b[r][i]) {
			ans[i][j.first] = b[r][i][j.first] - b[l][i][j.first];
		}
	}
	return ans;
}

int main() {
	ll n, q, step, l, r, ans, timer;
	cin >> n >> q;
	vector<long long> a(n);
	vector<vector<map<ll, ll>>> b(n+1, vector<map<ll, ll>> (148));
	vector<map<ll, ll>> ab;
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}
	step = 0;
	b[1][step][a[0]]++;
	while (a[0] % 2 == 0) {
		a[0] /= 2;
		step++;
		b[1][step][a[0]]++;
	}
	for (ll j = 2; j <= n; j++) {
		b[j] = b[j - 1];
		step = 0;
		b[j][step][a[j-1]]++;
		while (a[j-1] % 2 == 0 || step == n) {
			a[j-1] /= 2;
			step++;
			b[j][step][a[j-1]]++;
		}
	}
	while (q--) {
		cin >> l >> r;
		l--;
		ab = rizn(b, l, r);
		for (ans = 1; ans < ab.size(); ans++) {
			timer = 0;
			for (auto i : ab[ans]) {
				if (ab[ans-1][i.first] == 0) {
					ab[ans][i.first] = 0;
				}
				if (ab[ans][i.first] != 0) {
					timer++;
				}
			}
			if (timer == 0) {
				ans--;
				break;
			}
		}
		cout << ans << '\n';
	}
}